//------------------------------------------------------
// module  : FunctionUseful.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionUseful.h"
#include "PreProcDepthMapSeq.h"

//----------------------------------//
//----------------------------------//
//------- Allocation Memoire -------//
//----------------------------------//
//----------------------------------//
//---------------------------------------------------------
//  Alloue memoire pour matrice 1d de unsigned short int
//----------------------------------------------------------
unsigned short int* usimatrix_allocate_1d(int hsize)
 {
  unsigned short int* matrix;
  matrix=new unsigned short int[hsize]; return matrix; 
 }

//----------------------------------------------------------
// Alloue memoire pour matrice 2d de unsigned short int
//----------------------------------------------------------
unsigned short int** usimatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned short int** matrix;
  unsigned short int*  imptr;

  matrix=new unsigned short int*[vsize];
  imptr=new unsigned short int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// Alloue memoire pour matrice 3d de unsigned short int
//----------------------------------------------------------
unsigned short int*** usimatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  unsigned short int*** matrix;

  matrix=new unsigned short int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=usimatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// Libere memoire matrice 1d de unsigned short int
//----------------------------------------------------------
void free_usimatrix_1d(unsigned short int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// Libere memoire de la matrice 2d de unsigned short int
//----------------------------------------------------------
void free_usimatrix_2d(unsigned short int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// Libere memoire de la matrice 3d de unsigned short int
//----------------------------------------------------------
void free_usimatrix_3d(unsigned short int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//---------------------------------------------------------
//  Alloue memoire pour matrice 1d de unsigned char
//----------------------------------------------------------
unsigned char* ucmatrix_allocate_1d(int hsize)
 {
  unsigned char* matrix;
  matrix=new unsigned char[hsize]; return matrix; 
 }

//----------------------------------------------------------
// Alloue memoire pour matrice 2d de unsigned char
//----------------------------------------------------------
unsigned char** ucmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char*  imptr;

  matrix=new unsigned char*[vsize];
  imptr=new unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// Alloue memoire pour matrice 3d de unsigned char
//----------------------------------------------------------
unsigned char*** ucmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  unsigned char*** matrix;

  matrix=new unsigned char**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=ucmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// Libere memoire matrice 1d de unsigned char
//----------------------------------------------------------
void free_ucmatrix_1d(unsigned char* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// Libere memoire de la matrice 2d de unsigned char
//----------------------------------------------------------
void free_ucmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// Libere memoire de la matrice 3d de unsigned char
//----------------------------------------------------------
void free_ucmatrix_3d(unsigned char*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
{
    float* matrix;
    matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
{
    float** matrix;
    float *imptr;

    matrix=new float*[vsize];
    imptr=new  float[(hsize)*(vsize)];
    for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
    return matrix;
}

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
{
    float*** matrix;

    matrix=new float**[dsize];

    for(int i=0;i<dsize;i++)
        matrix[i]=fmatrix_allocate_2d(vsize,hsize);
    return matrix;
}

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de float
//----------------------------------------------------------
float**** fmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
{
    float**** matrix;

    matrix=new float***[fsize];

    for(int i=0;i<fsize;i++)
        matrix[i]=fmatrix_allocate_3d(dsize,vsize,hsize);
    return matrix;
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
    delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
    for(int i=0;i<dsize;i++)
    {
        delete[] (pmat[i][0]);
        delete[] (pmat[i]);
    }
    delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de float
//----------------------------------------------------------
void free_fmatrix_4d(float**** pmat,int fsize,int dsize)
{
    for(int i=0;i<fsize;i++)
        free_fmatrix_3d(pmat[i],dsize);

    delete[] (pmat);
}

//----------------------------------//
//----------------------------------//
//------------ Gestion -------------//
//----------------------------------//
//----------------------------------//
//----------------------------------------------------------
//  CopyMatrix
//----------------------------------------------------------
void CopyMatrix(unsigned short*** MatIn,unsigned short*** MatOut,\
int dpth,int lgth,int wdth)
{
 int i,j,k;

 for(k=0;k<dpth;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 MatOut[k][i][j]=MatIn[k][i][j];
}

void CopyMatrix(float*** pmatl1,float*** pmatl2,int lgth,int wdth,int nbcoul)
{
 int i,j,k;

 for(k=0;k<nbcoul;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 pmatl2[k][i][j]=pmatl1[k][i][j];
}

void CopyMatrix(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 mat2[i][j]=mat1[i][j];
}

//---------------------------------------------------
// Recal                               
//---------------------------------------------------
void Recal(float*** mat,int lgth,int wdth)
{
 int i,j,k;
 float max,min;
 float tmp;

 //Presentation
 printf("\n > RecalageA");

    //Boucle
    for(k=0;k<TROIS;k++)
    {
        min=max=mat[k][0][0];

        //>min/max
        for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if(mat[k][i][j]<min) min=mat[k][i][j];
        for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if(mat[k][i][j]>max) max=mat[k][i][j];

        //>Debug
        printf(" [min/max %.1f::%.1f]",min,max);
        fflush(stdout);

        //>Recalibre
        for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max)
        { tmp=((float)mat[k][i][j]-(float) min)*(GREY_LEVEL/(float)(max-min));
            if (tmp<0)    tmp=0.0;
            if (tmp>255) tmp=255.0;
            mat[k][i][j]=tmp; }
    }
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void Recal(float** mat,int lgth,int wdth)
{
    int i,j;
    float max,min;

    //Initialisation
    min = max = mat[0][0];

    //Recherche du min
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
        if (mat[i][j]<min) min=mat[i][j];

    //plus min
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
        mat[i][j]-=min;

    //Recherche du max
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
        if (mat[i][j]>max) max=mat[i][j];

    //Recalibre la matrice
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
        if (max) mat[i][j]*=(GREY_LEVEL/max);
}

//---------------------------------------------------
// RecalB                                  
//---------------------------------------------------
void RecalB(float*** mat,int lgth,int wdth)
{
 int i,j,k;
 float max,min;
 float tmp;

 //Presentation
 printf("\n > RecalageB:");

 //Min-Tranlation
 for(k=0;k<TROIS;k++)
    { min=mat[k][0][0];
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if(mat[k][i][j]<min) min=mat[k][i][j];
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[k][i][j]-=min; }
      //printf(" [min:%.1f]",min); }

 //MaxSeeking
 max=mat[0][0][0];
 for(k=0;k<TROIS;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if(mat[k][i][j]>max) max=mat[k][i][j];
 printf(" [max:%.1f]",max);

 //LinearStretch_[0::255]
 for(k=0;k<TROIS;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {  tmp=((float)mat[k][i][j])*(GREY_LEVEL/(float)(max));
       if (tmp<0)    tmp=0.0;
       if (tmp>255)  tmp=255.0; 
       mat[k][i][j]=tmp; }
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void RecalI(float** mat,int lgth,int wdth,float min,float max)
{
 int i,j;
 float scale;
 scale=max-min;

 //Recal [0-255]
 Recal(mat,lgth,wdth);

 //Recal [min-max]
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]*=scale/255.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]+=min;
}

//----------------------------------------------------------
// ComputeMean
//----------------------------------------------------------
float ComputeMean(float** mat,int lgth,int wdth)
{
 int i,j;
 float Moy;

 Moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy+=mat[i][j];
 Moy/=(lgth*wdth);

 return Moy;
}

//----------------------------------------------------------
// ComputeDiff
//----------------------------------------------------------
float ComputeDiff(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;
 float Diff;

 Diff=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Diff+=fabs(mat1[i][j]-mat2[i][j]);
 Diff/=(lgth*wdth);

 return Diff;
}

//----------------------------------------------------------
// ComputeDiff
//----------------------------------------------------------
float DiffMat(float** pmatl1,float** pmatl2,int lgth,int wdth,float precs)
{
 int i,j;
 float chg;

 //>Compte NbChgt
 chg=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (fabs(pmatl1[i][j]-pmatl2[i][j])>precs) chg++;
 chg/=(float)(lgth*wdth);
 chg*=100.0;

 return chg;
}

//----------------------------------------------------------
// Stat           
//----------------------------------------------------------     
void Stat(float** Img,int lgth,int wdth)
{
  int i,j;
  float min,max,moy;

  //Stats
  min=10000000.0;
  max=-10000000.0;
  moy=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { moy+=Img[i][j];
       if(min>Img[i][j]) min=Img[i][j];
       if(max<Img[i][j]) max=Img[i][j];  }
  moy/=(lgth*wdth);
  printf("\n     Stat::[min=%.1f | max=%.1f | Moy=%.0f]",min,max,moy);
  fflush(stdout);
}

//----------------------------------//
//----------------------------------//
//------------ Read File -----------//
//----------------------------------//
//----------------------------------//
//--------------------------------//
//-- Read (Depth Map Seq.) File --//
//--------------------------------// 
void ReadRawDepthMapSeqFile(char* PathName,unsigned short int*** ImgSeq,int n_o_im,int offset)
{
 //Main Header Bytes Number
 int head_size=4;
 //Image Header Bytes Number
 int imh_size=12;

 //Image Parameter
 int im_w=WIDTH;
 int im_h=HEIGHT;

 int temp;
 int i,j,k;
 FILE *file; 

 //MemoryAllocation
 unsigned short int* flush=new unsigned short int[imh_size];
 unsigned short int* pix=new unsigned short int;

 //OpenFile
 file=fopen(PathName,"r");
 if (file==NULL) 
    { printf("\n ->> Grave erreur a l'ouverture de %s -\n",PathName);
      exit(-1); }

 //Flushing (Header) 8 first char) (4 short int)
 temp=fread(flush,sizeof(unsigned short int),head_size,file);

 //Flushing Images (offset)
 for(k=0;k<offset;k++)
    {
     //Flushing (Header) 24 first char. (12 short int)
     temp=fread(flush,sizeof(unsigned short int),imh_size,file);

     for(i=0;i<im_w;i++) for(j=0;j<im_h;j++)
     temp=fread(pix,sizeof(unsigned short int),1,file);  }

 //Parsing Images (one at the time)
 for(k=0;k<n_o_im;k++)
    {
     //Flushing first 24 characters (12 short int)
     temp=fread(flush,sizeof(unsigned short int),imh_size,file);
     for(i=0;i<im_w;i++) for(j=0;j<im_h;j++)
	 {
          temp=fread(pix,sizeof(unsigned short int),1,file);
          ImgSeq[k][j][i]=(*pix); // Img Transposed 
         }       
     }

 //Close File
 fclose(file);
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(const char* Path_out,char* Name,char* Com,float*** matrvb,int lgth,int wdth)
{
    int i,j,k;
    char buff[200];
    FILE* fuser;

    //extension
    strcpy(buff,Path_out);
    strcat(buff,Name);
    strcat(buff,Com);
    strcat(buff,".ppm");

    //ouverture fichier
    fuser=fopen(buff,"w");
    if (fuser==NULL)
    { printf(" probleme dans la sauvegarde de %s",buff);
        exit(-1); }

    //affichage
    printf("\n Sauvegarde dans -> %s au format %s",buff,"ppm");
    fflush(stdout);

    //sauvegarde de l'entete
    fprintf(fuser,"P6");
    fprintf(fuser,"\n# %s \n",Com);
    fprintf(fuser,"%d %d",wdth,lgth);
    fprintf(fuser,"\n255\n");

    for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { matrvb[k][i][j]=(int)(matrvb[k][i][j]+0.49);
        if (matrvb[k][i][j]<0)   matrvb[k][i][j]=0;
        if (matrvb[k][i][j]>255) matrvb[k][i][j]=255; }

    //enregistrement
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { fprintf(fuser,"%c",(char)matrvb[0][i][j]);
        fprintf(fuser,"%c",(char)matrvb[1][i][j]);
        fprintf(fuser,"%c",(char)matrvb[2][i][j]); }

    //fermeture fichier
    fclose(fuser);
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(const char* Path_out,char* Name,char* Com,unsigned short*** matrvb,int lgth,int wdth)
{
    int i,j,k;
    char buff[200];
    FILE* fuser;

    //extension
    strcpy(buff,Path_out);
    strcat(buff,Name);
    strcat(buff,Com);
    strcat(buff,".ppm");

    //ouverture fichier
    fuser=fopen(buff,"w");
    if (fuser==NULL)
    { printf(" probleme dans la sauvegarde de %s",buff);
        exit(-1); }

    //affichage
    printf(" > Sauvegarde dans -> %s au format %s\n",buff,"ppm");
    fflush(stdout);

    //sauvegarde de l'entete
    fprintf(fuser,"P6");
    fprintf(fuser,"\n# %s \n",Com);
    fprintf(fuser,"%d %d",wdth,lgth);
    fprintf(fuser,"\n255\n");

    for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { matrvb[k][i][j]=(int)(matrvb[k][i][j]+0.49);
        //if (matrvb[k][i][j]<0)   matrvb[k][i][j]=0;
        if (matrvb[k][i][j]>255) matrvb[k][i][j]=255; }

    //enregistrement
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { fprintf(fuser,"%c",(char)matrvb[0][i][j]);
        fprintf(fuser,"%c",(char)matrvb[1][i][j]);
        fprintf(fuser,"%c",(char)matrvb[2][i][j]); }

    //fermeture fichier
    fclose(fuser);
}

//----------------------------------//
//----------------------------------//
//----------- Randomize ------------//
//----------------------------------//
//----------------------------------//
//---------------------------------------------------------------------
// randomize(
//---------------------------------------------------------------------
float randomize(void)
{ return (((float)rand())/RAND_MAX); }

//----------------------------------//
//----------------------------------//
//--------- Filtering --------------//
//----------------------------------//
//----------------------------------//
//---------------------------------------------------------------------
// Insertion sort
//----------------
// http://www.zentut.com/c-tutorial/insertion-sort-in-c/
//---------------------------------------------------------------------
void swap(unsigned char* x,unsigned char* y)
{
 int temp;
 temp = *x;
 *x = *y;
 *y = temp;
}

void insertion_sort(unsigned char *a,const int size)
{
 int i,j,k;
 for (i=1;i<size;++i)
     { 
      k=a[i];
      j=i-1;
      while ((j>=0)&&(k<a[j]))
        { a[j + 1] = a[j];
          --j; }
        a[j+1]=k;
     }
}

void MedianFilter3D(unsigned short*** seq,int depth,int height,int width,int s_win)
{
 int i,j,d;
 int nb;
 int r=s_win/2; //Radius
 int numel=(int)pow(s_win,3); //Number of element to sort

 unsigned char*** mat_tmp;
 unsigned char* vect;

 //Allocate Memory
 mat_tmp=ucmatrix_allocate_3d(depth,height,width);
 vect=ucmatrix_allocate_1d(numel);

 //Copy Matrix
 for(d=0;d<depth;d++) 
 for(j=0;j<height;j++) for(i=0;i<width;i++)
 mat_tmp[d][j][i]=seq[d][j][i];
           

 //Median Filter
 for(d=r;d<depth-r;d++) 
 for(j=r;j<height-r;j++) for(i=r;i<width-r;i++)
    {
     nb = 0;
     //depth window is smaller to increase computation time
     for(int k=-r;k<=r;k++) for(int l=-r;l<=r;l++) for(int m=-r; m <=r; m++)
     vect[nb++]=mat_tmp[d+k][j+l][i+m];

     insertion_sort(vect,numel);

     seq[d][j][i]= vect[numel/2];
    }

 //Free Memory
 free_ucmatrix_3d(mat_tmp,depth);
 free(vect);
}

void swap(unsigned short* x,unsigned short* y)
{
 int temp;
 temp = *x;
 *x = *y;
 *y = temp;
}

void insertion_sort(unsigned short *a,const int size)
{
 int i,j,k;
 for (i=1;i<size;++i)
     { 
      k=a[i];
      j=i-1;
      while ((j>=0)&&(k<a[j]))
        { a[j + 1] = a[j];
          --j; }
        a[j+1]=k;
     }
}

//----------------------------------//
//----------------------------------//
//-------- Statistiques ------------//
//----------------------------------//
//----------------------------------//
//---------------------------------------------------------------------
// Compute CorrelationMetrics
//---------------------------------------------------------------------
float CompCorrMetric(unsigned short*** seq,unsigned short*** map,int depth,\
int step,int ratio,int XMin,int XMax,int YMin,int Ymax)
{
 int i,j,k,l,m;

 //Area around the subject
 int x_min = XMin;
 int x_max = XMax;
 int y_min = YMin;
 int y_max = Ymax;

 //For pixels took at every step, the pairwise distance is
 //computed with pixel at an increasing distance
 //in such manner that it is a geometric progession
    
 //Compute number of pairs
 int nb_pairs = 0;
 for(i=x_min;i<x_max;i+=step) for(j=y_min;j<y_max;j+=step)
 for(k=1;k<x_max;k*=ratio) for(l=1;l<y_max;l*=ratio)
 if (((i+k)<x_max)&&((j+l)<y_max)) nb_pairs++;

  float* X=fmatrix_allocate_1d(nb_pairs);
  float* Y=fmatrix_allocate_1d(nb_pairs);
  float mean_X, mean_Y;
  float std_X, std_Y;

  printf(" [NbPairs:%d]",nb_pairs);

  
    //--------------------------------------
    //--- Making pairwise distance array ---
    //--------------------------------------
    //Original Matrix
    float _num, _diff;
    int el = 0;
    for(i=x_min;i<x_max;i+=step) for(j=y_min;j<y_max;j+=step)
    for(k=1;k<x_max;k*=ratio) for(l=1;l<y_max;l*=ratio)
    if (((i+k)<x_max)&&((j+l)<y_max))
       {
        _num=0.0;
        for(m=0; m<depth; m++)
           { _diff = seq[m][j][i] - seq[m][j+l][i+k];
             _num += pow(_diff, 2.0); }
             X[el] = (float) sqrt(_num) ;
             el++; }

    //Image Matrix
    el = 0;
    for(i=x_min;i<x_max;i+=step) for(j=y_min;j<y_max;j+=step)
    for(k=1;k<x_max;k*=ratio) for(l=1;l<y_max;l*=ratio)
    if (((i+k)<x_max)&&((j+l)<y_max))
       {
        _num=0.0;
        for(m=0; m<TROIS; m++)
           { _diff = map[m][j][i] - map[m][j+l][i+k];
             _num += pow(_diff, 2.0); }
             Y[el] = (float) sqrt(_num) ;
             el++; }

    //-------------------
    //--- Correlation ---
    //-------------------
    mean_X=0.0;
    for(int k=0;k<nb_pairs;k++) mean_X+=X[k];
    mean_X/=(float)nb_pairs;

    mean_Y=0.0;
    for(k=0;k<nb_pairs;k++) mean_Y+=Y[k];
    mean_Y/=(float)nb_pairs;

    std_X =0.0;
    for(int k=0;k<nb_pairs;k++) std_X+=pow(X[k] - mean_X, 2.0);
    std_X = sqrt(std_X/(float)nb_pairs);

    std_Y =0.0;
    for(k=0;k<nb_pairs;k++) std_Y+=pow(Y[k] - mean_Y, 2.0);
    std_Y = sqrt(std_Y/(float)nb_pairs);

    //Correlation
    float numerator = 0.0;
    for(k=0;k<nb_pairs;k++) numerator += X[k] * Y[k]; // XY
    numerator /= ((float) nb_pairs); // XY/|X|
    numerator -= mean_X * mean_Y;
    float corr = numerator/(std_X * std_Y);

    //Return
    return corr;
}

//--------------------------------
//--------------------------------
//---COLOR CONVERSION-------------
//--------------------------------
//--------------------------------
//--------------------------------
//---LAB>RGB----------------------
//--------------------------------
//----------------------------------------------------------
// Convert_LAB_TO_RGB                 
//----------------------------------------------------------
float Convert_LAB_TO_RGB(float*** mat,int lgth,int wdth,float*** matout)
{
    int i,j,l;
    int cptU,cptD,cptUD;
    float red,green,blue;
    float l_,a_,b_;
    float pourcU,pourcD,pourcUD;;

    //AllocationMemoire
    float*** mattmp=fmatrix_allocate_3d(TROIS,lgth,wdth);
    float*** mattmp2=fmatrix_allocate_3d(TROIS,lgth,wdth);

    //Tampon
    for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[l][i][j]=mat[l][i][j];
    for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp2[l][i][j]=mattmp[l][i][j];
    for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[l][i][j]=0;

    //LAB>RGB
    cptD=0;
    cptU=0;
    cptUD=0;
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { LABToRGB(mattmp[0][i][j],mattmp[1][i][j],mattmp[2][i][j],&red,&green,&blue);
        if ((red>255)||(green>255)||(blue>255))  cptU++;
        if ((red<0)||(green<0)||(blue<0))        cptD++;
        if ((red>255)||(green>255)||(blue>255)||((red<0)||(green<0)||(blue<0))) cptUD++;

        if (red>255)   red=255;
        if (green>255) green=255;
        if (blue>255)  blue=255;
        if (red<0)     red=0;
        if (green<0)   green=0;
        if (blue<0)    blue=0;

        matout[0][i][j]=(int)red;
        matout[1][i][j]=(int)green;
        matout[2][i][j]=(int)blue;  }

    pourcU=(float)100.0*cptU/(lgth*wdth);
    pourcD=(float)100.0*cptD/(lgth*wdth);
    pourcUD=(float)100.0*cptUD/(lgth*wdth);
    printf("\n > [pcU=%.1f PourCent][pcD=%.1f PourCent][pcUD=%.1f PourCent]",pourcU,pourcD,pourcUD);

    //ReVerif::Calcul Pourcentage pixels staures
    cptUD=0;
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { RGBToLAB(matout[0][i][j],matout[1][i][j],matout[2][i][j],&l_,&a_,&b_);
        if ((fabs(l_-mattmp2[0][i][j])>0.5)||(fabs(a_-mattmp2[1][i][j])>0.5)||(fabs(b_-mattmp2[2][i][j])>0.5))
            cptUD++; }
    pourcUD=(float)100.0*cptUD/(lgth*wdth);
    printf(">[pcUD=%.2f PourCent]",pourcUD);

    //Liberation Memoire
    if (mattmp)   free_fmatrix_3d(mattmp,TROIS);
    if (mattmp2)  free_fmatrix_3d(mattmp2,TROIS);

    //Retour
    return pourcUD;
}

//----------------------------------------------------------*/
// LABToRGB                    
//----------------------------------------------------------*/
void LABToRGB(float l,float a,float b,float* r,float* g,float* bl)
{
    float x,y,z;

    LABToXYZ(l,a,b,&x,&y,&z);
    XYZToRGB(x,y,z,r,g,bl);
}

//----------------------------------------------------------
// LABToXYZ 
//----------------------------------------------------------
void LABToXYZ(float l,float a,float b,float* x,float* y,float* z)
{
    (*y)=(l+16.0)/116.0;
    (*x)=a/500.0+(*y);
    (*z)=(*y)-b/200.0;

    if (powf((*y),3)>0.008856)  (*y)=powf((*y),3);
    else                        (*y)=((*y)-16.0/116.0)/7.787;
    if (powf((*x),3)>0.008856)  (*x)=powf((*x),3);
    else                        (*x)=((*x)-16.0/116.0)/7.787;
    if (pow((*z),3)>0.008856)   (*z)=powf((*z),3);
    else                        (*z)=((*z)-16.0/116.0)/7.787;

    (*x)=95.047*(*x);
    (*y)=100.000*(*y);
    (*z)=108.883*(*z);
}

//----------------------------------------------------------
// XYZToRGB 
//----------------------------------------------------------
void XYZToRGB(float x,float y,float z,float* r,float* g,float* b)
{
    x=x/100.0;   //X from 0 to  95.047
    y=y/100.0;   //Y from 0 to 100.000
    z=z/100.0;   //Z from 0 to 108.883

    (*r)=x*3.2406+y*(-1.5372)+z*(-0.4986);
    (*g)=x*(-0.9689)+y*(1.8758)+z*0.0415;
    (*b)=x*0.0557+y*(-0.2040)+z*1.0570;

    if ((*r)>0.0031308) (*r)=1.055*(powf((*r),(1.0/2.4)))-0.055;
    else                (*r)=12.92*(*r);
    if ((*g)>0.0031308) (*g)=1.055*(powf((*g),(1.0/2.4)))-0.055;
    else                (*g)=12.92*(*g);
    if ((*b)>0.0031308) (*b)=1.055*(powf((*b),(1.0/2.4)))-0.055;
    else                (*b)=12.92*(*b);

    (*r)=(*r)*255.0;
    (*g)=(*g)*255.0;
    (*b)=(*b)*255.0;
}

//--------------------------------
//---RGB>LAB----------------------
//--------------------------------
//----------------------------------------------------------*/
// RGBToLAB                     
//----------------------------------------------------------*/
void RGBToLAB(float r,float g,float bl,float* l,float* a,float* b)
{
    float x,y,z;

    RGBToXYZ(r,g,bl,&x,&y,&z);
    XYZToLAB(x,y,z,l,a,b);
}

//----------------------------------------------------------*/
// RGBToXYZ                    
//----------------------------------------------------------*/
void RGBToXYZ(float r,float g,float b,float* x,float* y,float* z)
{
    r=(r/255.0);         //R from 0 to 255
    g=(g/255.0);         //G from 0 to 255
    b=(b/255.0);         //B from 0 to 255

    if (r>0.04045) r=powf(((r+0.055)/1.055),2.4);
    else           r=r/12.92;
    if (g>0.04045) g=powf(((g+0.055)/1.055),2.4);
    else           g=g/12.92;
    if (b>0.04045) b=powf(((b+0.055)/1.055),2.4);
    else           b=b/12.92;

    r=r*100;
    g=g*100;
    b=b*100;

    (*x)=r*0.4124 + g*0.3576 + b*0.1805;
    (*y)=r*0.2126 + g*0.7152 + b*0.0722;
    (*z)=r*0.0193 + g*0.1192 + b*0.9505;
}

//----------------------------------------------------------*/
// XYZToLAB                     
//----------------------------------------------------------*/
void XYZToLAB(float x,float y,float z,float* l,float* a,float* b)
{
    x=x/95.047;
    y=y/100.000;
    z=z/108.883;

    if (x>0.008856) x=powf(x,1.0/3.0);
    else            x=(7.787*x)+(16.0/116.0);
    if (y>0.008856) y=powf(y,1.0/3.0);
    else            y=(7.787*y)+(16.0/116.0);
    if (z>0.008856) z=powf(z,1.0/3.0);
    else            z=(7.787*z)+(16.0/116.0);

    (*l)=(116.0*y)-16.0;
    (*a)=500.0*(x-y);
    (*b)=200.0*(y-z);
}

//--------------------------------
//--------------------------------
//---FFT--------------------------
//--------------------------------
//--------------------------------
void fourn(float data[], unsigned long nn[], int ndim, int isign)
{
    int idim;
    unsigned long i1,i2,i3,i2rev,i3rev,ip1,ip2,ip3,ifp1,ifp2;
    unsigned long ibit,k1,k2,n,nprev,nrem,ntot;
    float tempi,tempr;
    double theta,wi,wpi,wpr,wr,wtemp;

    for (ntot=1,idim=1;idim<=ndim;idim++)
        ntot *= nn[idim];
    nprev=1;
    for (idim=ndim;idim>=1;idim--) {
        n=nn[idim];
        nrem=ntot/(n*nprev);
        ip1=nprev << 1;
        ip2=ip1*n;
        ip3=ip2*nrem;
        i2rev=1;
        for (i2=1;i2<=ip2;i2+=ip1) {
            if (i2 < i2rev) {
                for (i1=i2;i1<=i2+ip1-2;i1+=2) {
                    for (i3=i1;i3<=ip3;i3+=ip2) {
                        i3rev=i2rev+i3-i2;
                        SWAP(data[i3],data[i3rev]);
                        SWAP(data[i3+1],data[i3rev+1]);
                    }
                }
            }
            ibit=ip2 >> 1;
            while (ibit >= ip1 && i2rev > ibit) {
                i2rev -= ibit;
                ibit >>= 1;
            }
            i2rev += ibit;
        }
        ifp1=ip1;
        while (ifp1 < ip2) {
            ifp2=ifp1 << 1;
            theta=isign*6.28318530717959/(ifp2/ip1);
            wtemp=sin(0.5*theta);
            wpr = -2.0*wtemp*wtemp;
            wpi=sin(theta);
            wr=1.0;
            wi=0.0;
            for (i3=1;i3<=ifp1;i3+=ip1) {
                for (i1=i3;i1<=i3+ip1-2;i1+=2) {
                    for (i2=i1;i2<=ip3;i2+=ifp2) {
                        k1=i2;
                        k2=k1+ifp1;
                        tempr=(float)wr*data[k2]-(float)wi*data[k2+1];
                        tempi=(float)wr*data[k2+1]+(float)wi*data[k2];
                        data[k2]=data[k1]-tempr;
                        data[k2+1]=data[k1+1]-tempi;
                        data[k1] += tempr;
                        data[k1+1] += tempi;
                    }
                }
                wr=(wtemp=wr)*wpr-wi*wpi+wr;
                wi=wi*wpr+wtemp*wpi+wi;
            }
            ifp1=ifp2;
        }
        nprev *= n;
    }
}

//----------------------------------------------------------
// MyFFT1D                                                    
//----------------------------------------------------------
void MyFFT1D(float* vctR,float* vctI,int lgth)
{
    int i;
    float* data;
    unsigned long* nn;

    /*allocation memoire*/
    data=(float*)malloc(sizeof(float)*((2*lgth)+1));
    nn=(unsigned long*)malloc(sizeof(unsigned long)*2);
    nn[1]=lgth;

    /*Remplissage de data*/
    for(i=0;i<lgth;i++)
    { data[(2*i)+1]=vctR[i];
        data[(2*i)+2]=vctI[i];
    }

    /*FFTDD*/
    fourn(data,nn,1,1); // the last parameter is to select FFT

    /*Resultat*/
    for(i=0;i<lgth;i++)
    { vctR[i]=data[(2*i)+1];
        vctI[i]=data[(2*i)+2];  }

    /*Liberation memoire*/
    free(data);
    free(nn);
}
