//------------------------------------------------------
// module  : FunctionUseful.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
//   

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200
#define TROIS 3
#define GREY_LEVEL 255.0
#define CARRE(X) ((X)*(X))
#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr


//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------
//>Matrix Allocation
unsigned short*    usimatrix_allocate_1d(int);
unsigned short**   usimatrix_allocate_2d(int,int);
unsigned short***  usimatrix_allocate_3d(int,int,int);
unsigned char*     ucmatrix_allocate_1d(int);
unsigned char**    ucmatrix_allocate_2d(int,int);
unsigned char***   ucmatrix_allocate_3d(int,int,int);
float*             fmatrix_allocate_1d(int);
float**            fmatrix_allocate_2d(int,int);
float***           fmatrix_allocate_3d(int,int,int);
float****          fmatrix_allocate_4d(int,int,int,int);
void  free_usimatrix_1d(unsigned short int*);
void  free_usimatrix_2d(unsigned short int**);
void  free_usimatrix_3d(unsigned short int***,int);
void  free_ucmatrix_1d(unsigned char*);
void  free_ucmatrix_2d(unsigned char**);
void  free_ucmatrix_3d(unsigned char***,int);
void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_fmatrix_4d(float****,int,int);

//>Matrix Gestion
void CopyMatrix(unsigned short***,unsigned short***,int,int,int);
void CopyMatrix(float***,float***,int,int,int);
void CopyMatrix(float**,float**,int,int);
void Recal(float***,int,int);
void Recal(float**,int,int);
void RecalB(float***,int,int);
void RecalI(float**,int,int,float,float);
float ComputeMean(float**,int,int);
float ComputeDiff(float**,float**,int,int);
float DiffMat(float**,float**,int,int,float);
void  Stat(float**,int,int);

//>Read (Depth Map Seq.) File
void ReadRawDepthMapSeqFile(char*,unsigned short int***,int,int);
void SaveImagePpm(const char*,char*,char*,float***,int,int);
void SaveImagePpm(const char*,char*,char*,unsigned short***,int,int);

//>Randomize
float randomize(void);

//>Filtering
void swap(unsigned char*,unsigned char*);
void insertion_sort(unsigned char*,int);
void MedianFilter3D(unsigned short***,int,int,int,int);
void swap(unsigned short*,unsigned short*);
void insertion_sort(unsigned short*,int);

//>Stats
float CompCorrMetric(unsigned short***,unsigned short***,int,int,int,int,int,int,int);

//>Color Conversion
float Convert_LAB_TO_RGB(float***,int,int,float***);
void LABToRGB(float,float,float,float*,float*,float*);
void LABToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToLAB(float,float,float,float*,float*,float*);

//>Fourier
void fourn(float*,unsigned long*,int,int);
void MyFFT1D(float*,float*,int);
