//---------------------------------------------------
// module  : MdsBasedSymEst.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef MDSBASEDSYMEST_H
#define MDSBASEDSYMEST_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionUseful.h"
#include "FastMap.h"
#include "PreProcDepthMapSeq.h"

// 
//
// GaitAnalysis S05_A.dat -f 300 -o 400
// <Cor_88_90_Nrj_4031_463_ASI_2064>
//
// A essayer:
// Cnx=35 et step_size=3 [6]
//
//------------------------------------------------
// MODEL PARAMETERS ------------------------------
//------------------------------------------------
//RefiningMinimization
#define NBCNXGRAPH     15      //Ok! 
#define WINDSIZEEXPLOR 13      //Ok! 

#define FACT_PRIOR      0.025  //0k! 
#define Q_PRIOR         2.0    //Ok!
#define RADIUS          7      //Ok!
#define MAX_ITER      200      //Ok!

#define STOCHAST        0 
#define TEMPINIT        1     //Ok!
#define TEMPFINA        0.001 //Ok! 
#define PREC_MET        1     //Ok! 


//------------------------------------------------
// CLASS MdsBasedSymEst --------------------------
//------------------------------------------------
class MdsBasedSymEst 
{
  //---Data----
  //-----------
  public:

  //Matrix
  unsigned short*** DepthMapSeq;

  float*** RawMdsSymMap;
  float*** ProcMdsSymMap;
  float*** RGBMdsSymMap;

  //Graph
  unsigned short*** NonLocalGraph;
 
  //Parameters_In
  int depth,height,width;
  int NumbCnx,ExploreWinSize;

  //Parameters_Out
  float ScalingFact; 
  float FactPrior;
  
  float CorelRaw,CorelRefined;
  float NrjBeg,NrjEnd;
  float ASIndx;
  float PourcPixSatRGB;
  float ElapsedTime; 
  float* ASIcurve;

  //Options
  int DistMap;
  int FlgRefining;
  int FlgStoch;

  //Useful
  char Name[NCHAR];
  char Info[NCHAR];
  char Extension[NCHAR];
  char ExtensionASI[NCHAR];

  //--Methods--
  //------------
  public:
  MdsBasedSymEst(char*,unsigned short***,int,int,int);
  ~MdsBasedSymEst();

  //Main Methods
  void MdsRoughEstimation(int,unsigned short***);
  void ComputeNonLocalGraph(int,int);
  void MetropolisRefine(unsigned short***,float,float,float,int);
  void ColorConvLABtoRGBNonSat(unsigned short***);
  float EstimateASI(float***);

  //Gestion
  void  Compute_NonLocalGraph(unsigned short***,int,unsigned short***,int,int,int,int);
  void  ScaleDistNonLocalGrph(float);
  float Compute_Scaling_Factor();
  float Compute_Global_Energy(float***,float,float);
  float Compute_Local_Energy(float***,int,int,float*,float,float);
  void  Set_Good_Range_LAB();

  //Distance
  float Myobdist(float*,float*,int);

  //Info_&_Save
  void FillInfoNameDist();
  void GiveResumeInfo();
  void SaveCurveASI();
  void SaveImagePpm(const char*,char*,char*,unsigned short***,int,int);

  //Visu_Clusters
  void VisuThreeClusters();
  void ReduceCurveASI_2Dpts();
};

#endif 
