//---------------------------------------------------
// module  : PreProcDepthMapSeq.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef PREPROCDEPTHMAPSEQ_H
#define PREPROCDEPTHMAPSEQ_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionUseful.h"


//------------------------------------------------
// MODEL PATHS -----------------------------------
//------------------------------------------------
//Paths DepthMapSeq
//#define PATH_DEPTHMAPSEQ "../DATA/"
#define PATH_DEPTHMAPSEQ ""

//------------------------------------------------
// MODEL PARAMETERS ------------------------------
//------------------------------------------------
//Images Dimensions
#define HEIGHT  640
#define WIDTH   480
//#define DMAP    3 //Color Map Depth 

//Silouhette Retrieval (Cube Coord. around subject in 2D Image)
#define PATIENT_XMIN        155
#define PATIENT_XMAX        380
#define PATIENT_YMIN        28
#define PATIENT_YMAX        620
#define PATIENT_ZMIN        1700.0
#define PATIENT_ZMAX        2850.0

#define Y_TREADMILL_TRESH   845.0    //3D parameters for cropping
#define KINECT_FOCAL        575.82

#define NORM_FACTOR         255.0   
#define MEDIAN_W_SIZE       3        //5

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200

//------------------------------------------------
// CLASS [PreProcDepthMapSeq] --------------------
//------------------------------------------------
class PreProcDepthMapSeq 
{
  //---Data----
  //-----------
  public:

  //Matrix
  unsigned short int***  RawDepthMapSeq;
  unsigned short int***  ProcDepthMapSeq;
 
  //MatrixParameters
  int depth,height,width;
  int DistMap;

  //Useful
  char Name[NCHAR];

  //Option
  int FlagMedian;

  //--Methods--
  //------------
  public:
  PreProcDepthMapSeq(char*,int,int,int);
  ~PreProcDepthMapSeq();

  //--------------
  void Segmente_Silouhette(unsigned short***,unsigned short***,float,int);
};

#endif 
